using System;
using System.Resources;
using System.Reflection;

namespace GroupFinity.Greplace
{
	/// <summary>
	/// [JCYꂽAgr[gł邱Ƃ錾܂B
	/// </summary>
	public interface ILocalizedAttribute
	{
		/// <summary>
		/// ̑\[X擾AZu擾܂͐ݒ肵܂B
		/// </summary>
		Assembly Assembly{ get;set; }
	}

	/// <summary>
	/// AZũvOCƂĂ̏ݒ肷邽߂̃JX^`܂B
	/// </summary>
	[AttributeUsage( AttributeTargets.Assembly )]
	public class AssemblyPluginInformationAttribute : Attribute
	{
		/// <summary>
		/// AssemblyPluginInformationAttribute NX̐VCX^X܂B
		/// </summary>
		/// <param name='name'>vOC̖Ow肵܂B</param>
		public AssemblyPluginInformationAttribute( string name ){ Name = name; }

		/// <summary>
		/// ̃vOC̖O擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̖O</value>
		public virtual string Name{ get{ return name; } set{ name = value; } }
		private string name;

		/// <summary>
		/// ̃vOC̐擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̐</value>
		public virtual string Description{ get{ return description; } set{ description = value; } }
		private string description;

		/// <summary>
		/// ̃vOC̒쌠ȂǂɊւ擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̒쌠ȂǂɊւ</value>
		public virtual string Copyright{ get{ return copyright; } set{ copyright = value; } }
		private string copyright;

		/// <summary>
		/// ̃vOC̐҂ɃR^Ng邽߂̃AhX擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̐҂ɃR^Ng邽߂̃AhX</value>
		public string Url{ get{ return url; } set{ url = value; } }
		private string url;
	}

	/// <summary>
	/// AZũvOCƂĂ̏ݒ肷邽߂̃[JCYꂽJX^`܂B
	/// </summary>
	[AttributeUsage( AttributeTargets.Assembly )]
	public class AssemblyLocalizedPluginInformationAttribute : AssemblyPluginInformationAttribute, ILocalizedAttribute
	{
		/// <summary>
		/// AssemblyLocalizedPluginInformationAttribute NX̐VCX^X܂B
		/// </summary>
		/// <param name='resourceName'>̑gp郊\[X̃x[Xw肵܂B</param>
		/// <param name='name'>vOC̖Ow肵܂B
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B</param>
		public AssemblyLocalizedPluginInformationAttribute( string resourceName, string name ) : base( name ){ ResourceName = resourceName; }

		/// <summary>
		/// ̃vOC̖O擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̖O</value>
		public override string Name
		{
			get{ return GetLocalizedString( base.Name ); }
			set{ base.Name = value; }
		}

		/// <summary>
		/// ̃vOC̐擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̐</value>
		public override string Description
		{
			get{ return GetLocalizedString( base.Description ); }
			set{ base.Description = value; }
		}

		/// <summary>
		/// ̃vOC̒쌠ȂǂɊւ擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̃vOC̒쌠ȂǂɊւ</value>
		public override string Copyright
		{
			get{ return GetLocalizedString( base.Copyright ); }
			set{ base.Copyright = value; }
		}

		/// <summary>
		/// ̑gp郊\[X̃x[X擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̑gp郊\[X̃x[X</value>
		public string ResourceName{ get{ return resourceName; } set{ resourceName = value; } }
		private string resourceName;
		
		/// <summary>
		/// ̑\[X擾AZu擾܂͐ݒ肵܂B
		/// ̃vpeB Greplace ɂĎgp܂AvOCJ҂͎gpȂłB
		/// </summary>
		/// <value>̑\[X擾AZu</value>
		public Assembly Assembly{ get{ return assembly; } set{ assembly = value; } }
		private Assembly assembly;

		private string GetLocalizedString( string name )
		{
			return new ResourceManager( ResourceName, Assembly ).GetString( name );
		}
	}

	/// <summary>
	/// JX^ Evaluator ̏ݒ肷邽߂̃JX^`܂B
	/// Ǝɒ` Evaluator  Greplace 猩悤ɂ邽߂ɕKݒ肷Kv܂B
	/// </summary>
	[AttributeUsage(AttributeTargets.Class)]
	public class EvaluatorAttribute : Attribute
	{

		/// <summary>
		/// EvaluatorAttribute ̐VCX^XP Evaluator Ƃď܂B
		/// </summary>
		/// <param name='name'> Evaluator ̖OB</param>
		/// <param name='id'>̃IuWFNg̒P Evaluator ƂĂ̎ʎq</param>
		public EvaluatorAttribute( string name, char id ){ Name = name; CharId = id; }

		/// <summary>
		/// EvaluatorAttribute ̐VCX^X𕡎G Evaluator Ƃď܂B
		/// </summary>
		/// <param name='name'> Evaluator ̖OB</param>
		/// <param name='id'>̃IuWFNg̕G Evaluator ƂĂ̎ʎq</param>
		public EvaluatorAttribute( string name, string id ){ Name = name; StringId = id; }

		/// <summary>
		/// ̃IuWFNg̒P Evaluator ƂĂ̎ʎq擾܂͐ݒ肵܂B
		/// ̎ʎq $x ̂悤Ɏgp܂
		/// </summary>
		/// <value>̃IuWFNg̒P Evaluator ƂĂ̎ʎq</value>
		public char CharId{ get{ return charId; } set{ charId = value; atomic = true; } }
		private char charId;

		/// <summary>
		/// ̃IuWFNg̕G Evaluator ƂĂ̎ʎq擾܂͐ݒ肵܂B
		/// ̎ʎq ${id:text} ̂悤Ɏgp܂
		/// </summary>
		/// <value>̃IuWFNg̕G Evaluator ƂĂ̎ʎq</value>
		public string StringId{ get{ return stringId; } set{ stringId = value; atomic = false; } }
		private string stringId;

		/// <summary>
		///  Evaluator Pǂ擾܂B
		/// </summary>
		/// <value> Evaluator Pǂ</value>
		public bool IsAtomic{ get{ return atomic; } }
		private bool atomic;

		/// <summary>
		///  Evaluator ̖O擾܂͐ݒ肵܂B
		/// </summary>
		/// <value> Evaluator ̖O</value>
		public virtual string Name{ get{ return name; } set{ name = value; } }
		private string name;

		/// <summary>
		///  Evaluator ̐擾܂͐ݒ肵܂B
		/// </summary>
		/// <value> Evaluator ̐</value>
		public virtual string Description{ get{ return description; } set{ description = value; } }
		private string description;
	}

	/// <summary>
	/// JX^ Evaluator ̏ݒ肷邽߂̃[JCYꂽJX^`܂B
	/// Ǝɒ` Evaluator  Greplace 猩悤ɂ邽߂ɕKݒ肷Kv܂B
	/// </summary>
	[AttributeUsage(AttributeTargets.Class)]
	public class LocalizedEvaluatorAttribute : EvaluatorAttribute, ILocalizedAttribute
	{
		/// <summary>
		/// LocalizedEvaluatorAttribute ̐VCX^XP Evaluator Ƃď܂B
		/// ̑gp郊\[X̃x[X́AAZuɐݒ肳ꂽ <see>AssemblyLocalizedPluginInformationAttribute</see> 擾܂B
		/// </summary>
		/// <param name='name'> Evaluator ̖OB
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B</param>
		/// <param name='id'>̃IuWFNg̒P Evaluator ƂĂ̎ʎq</param>
		/// <seealso cref='GroupFinity.Greplace.AssemblyLocalizedPluginInformationAttribute'/>
		public LocalizedEvaluatorAttribute( string name, char id ) : base( name, id ){ }

		/// <summary>
		/// LocalizedEvaluatorAttribute ̐VCX^X𕡎G Evaluator Ƃď܂B
		/// ̑gp郊\[X̃x[X́AAZuɐݒ肳ꂽ <see>AssemblyLocalizedPluginInformationAttribute</see> 擾܂B
		/// </summary>
		/// <param name='name'> Evaluator ̖OB
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B</param>
		/// <param name='id'>̃IuWFNg̕G Evaluator ƂĂ̎ʎq</param>
		/// <seealso cref='GroupFinity.Greplace.AssemblyLocalizedPluginInformationAttribute'/>
		public LocalizedEvaluatorAttribute( string name, string id ) : base( name, id ){}

		/// <summary>
		/// LocalizedEvaluatorAttribute ̐VCX^XP Evaluator Ƃď܂B
		/// </summary>
		/// <param name='resourceName'>̑gp郊\[X̃x[Xw肵܂B</param>
		/// <param name='name'> Evaluator ̖OB
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B</param>
		/// <param name='id'>̃IuWFNg̒P Evaluator ƂĂ̎ʎq</param>
		public LocalizedEvaluatorAttribute( string resourceName, string name, char id ): base( name, id ){ ResourceName = resourceName; }

		/// <summary>
		/// LocalizedEvaluatorAttribute ̐VCX^X𕡎G Evaluator Ƃď܂B
		/// </summary>
		/// <param name='resourceName'>̑gp郊\[X̃x[Xw肵܂B</param>
		/// <param name='name'> Evaluator ̖OB
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B
		/// </param>
		/// <param name='id'>̃IuWFNg̕G Evaluator ƂĂ̎ʎq</param>
		public LocalizedEvaluatorAttribute( string resourceName, string name, string id ): base( name, id ){ ResourceName = resourceName; }

		/// <summary>
		///  Evaluator ̖O擾܂͐ݒ肵܂B
		/// </summary>
		/// <value> Evaluator ̖O</value>
		public override string Name{ get{ return GetLocalizedString( base.Name ); } set{ base.Name = value; } }
		
		/// <summary>
		///  Evaluator ̐擾܂͐ݒ肵܂B
		/// </summary>
		/// <value> Evaluator ̐</value>
		public override string Description{ get{ return GetLocalizedString( base.Description ); } set{ base.Description = value; } }

		/// <summary>
		/// ̑gp郊\[X̃x[X擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̑gp郊\[X̃x[X</value>
		public string ResourceName{ get{ return resourceName; } set{ resourceName = value; } }
		private string resourceName;
		
		/// <summary>
		/// ̑\[X擾AZu擾܂͐ݒ肵܂B
		/// ̃vpeB Greplace ɂĎgp܂AvOCJ҂͎gpȂłB
		/// </summary>
		/// <value>̑\[X擾AZu</value>
		public Assembly Assembly{ get{ return assembly; } set{ assembly = value; } }
		private Assembly assembly;

		private string GetLocalizedString( string name )
		{
			try
			{
				if ( ResourceName==null )
				{
					AssemblyLocalizedPluginInformationAttribute attr =
						GetCustomAttribute( Assembly, typeof( AssemblyLocalizedPluginInformationAttribute ), true )
						as AssemblyLocalizedPluginInformationAttribute;
					if ( attr!=null ) ResourceName = attr.ResourceName;
				}

				return new ResourceManager( ResourceName, Assembly ).GetString( name );
			}
			catch{ return string.Empty; }
		}
	}

	/// <summary>
	/// JX^ Evaluator ̎g킷JX^`܂B
	/// </summary>
	/// <remarks>
	/// <para>
	/// ̑w肷 Greplace {̂ŒueLXgQƂ郁j[
	/// JX^ Evaluator ̎gp\邱Ƃł܂B
	/// </para>
	/// </remarks>
	[AttributeUsage(AttributeTargets.Class, AllowMultiple=true)]
	public class EvaluatorUsageAttribute : Attribute
	{
		/// <summary>
		/// EvaluatorUsageAttribute ̐VCX^X܂B
		/// </summary>
		/// <param name='caption'>̎gp@̐eLXgw肵܂B
		/// </param>
		/// <param name='sample'>̓IȎgpw肵܂B</param>
		public EvaluatorUsageAttribute( string caption, string sample ){ Caption = caption; Sample = sample; }

		/// <summary>
		/// ̎gp@̖O擾܂͐ݒ肵܂B
		/// ̒l̓j[ɕ\܂B
		/// </summary>
		/// <value>̎gp@̖O</value>
		public virtual string Caption{ get{ return caption; } set{ caption = value; } }
		private string caption;

		/// <summary>
		/// ̑Ɋւgp擾܂͐ݒ肵܂B
		/// ̒l Greplace {̂Ńj[IƂɓ͗Ɏۂɑ}镶łB
		/// </summary>
		/// <remarks>
		/// <para>̒l͓͂ۂɓ͗ŌݑIĂ镔̑Oɑ}镶
		/// ɑ}镶Xy[Xŋ؂Ďw肵܂B</para>
		/// </remarks>
		/// <value>̑Ɋւgp</value>
		public string Sample{ get{ return sample; } set{ sample = value; } }
		private string sample;
	}

	/// <summary>
	/// JX^ Evaluator ̎g킷[JCYꂽJX^`܂B
	/// </summary>
	/// <remarks>
	/// <para>
	/// ̑w肷 Greplace {̂ŒueLXgQƂ郁j[
	/// JX^ Evaluator ̎gp\邱Ƃł܂B
	/// </para>
	/// </remarks>
	[AttributeUsage(AttributeTargets.Class, AllowMultiple=true)]
	public class LocalizedEvaluatorUsageAttribute : EvaluatorUsageAttribute, ILocalizedAttribute
	{
		/// <summary>
		/// LocalizedEvaluatorUsageAttribute ̐VCX^X܂B
		/// ̑gp郊\[X̃x[X́AAZuɐݒ肳ꂽ <see>AssemblyLocalizedPluginInformationAttribute</see> 擾܂B
		/// </summary>
		/// <param name='caption'>̎gp@̐eLXgw肵܂B
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B
		/// </param>
		/// <param name='sample'>̓IȎgpw肵܂B</param>
		/// <seealso cref='GroupFinity.Greplace.AssemblyLocalizedPluginInformationAttribute'/>
		public LocalizedEvaluatorUsageAttribute( string caption, string sample ) : base( caption, sample ){}

		/// <summary>
		/// LocalizedEvaluatorUsageAttribute ̐VCX^X܂B
		/// </summary>
		/// <param name='resourceName'>̑gp郊\[X̃x[Xw肵܂B</param>
		/// <param name='caption'>̎gp@̐eLXgw肵܂B
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B
		/// </param>
		/// <param name='sample'>̓IȎgpw肵܂B</param>
		public LocalizedEvaluatorUsageAttribute( string resourceName, string caption, string sample ) : base( caption, sample ){ ResourceName = resourceName; }

		/// <summary>
		/// ̎gp@̖O擾܂͐ݒ肵܂B
		/// ̒l̓j[ɕ\܂B
		/// </summary>
		/// <value>̎gp@̖O</value>
		public override string Caption{ get{ return GetLocalizedString( base.Caption ); } set{ base.Caption = value; } }

		/// <summary>
		/// ̑gp郊\[X̃x[X擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̑gp郊\[X̃x[X</value>
		public string ResourceName{ get{ return resourceName; } set{ resourceName = value; } }
		private string resourceName;
		
		/// <summary>
		/// ̑\[X擾AZu擾܂͐ݒ肵܂B
		/// ̃vpeB Greplace ɂĎgp܂AvOCJ҂͎gpȂłB
		/// </summary>
		/// <value>̑\[X擾AZu</value>
		public Assembly Assembly{ get{ return assembly; } set{ assembly = value; } }
		private Assembly assembly;

		private string GetLocalizedString( string name )
		{
			try
			{
				if ( ResourceName==null )
				{
					AssemblyLocalizedPluginInformationAttribute attr =
						GetCustomAttribute( Assembly, typeof( AssemblyLocalizedPluginInformationAttribute ), true )
						as AssemblyLocalizedPluginInformationAttribute;
					if ( attr!=null ) ResourceName = attr.ResourceName;
				}

				return new ResourceManager( ResourceName, Assembly ).GetString( name );
			}
			catch{ return string.Empty; }
		}
	}


	/// <summary>
	/// vOCJX^ Evaluator ̎gݒ_CAOɊւJX^`܂B
	/// </summary>
	/// <remarks>
	/// <para>
	/// ̑w肷ƃvOCJX^ Evaluator Ɋւ\ׂ̃_CAO
	/// Greplace J悤ɂȂ܂B
	/// </para>
	/// </remarks>
	[AttributeUsage(AttributeTargets.Class|AttributeTargets.Assembly)]
	public class OptionPageAttribute : Attribute
	{
		/// <summary>
		/// OptionPageAttribute ̐VCX^X܂B
		/// </summary>
		/// <param name='caption'>̎gp@̐eLXgw肵܂B
		/// </param>
		/// <param name='type'>[U[j[NbNƂɃCX^X쐬^w肵܂B</param>
		public OptionPageAttribute( string caption, Type type ){ Caption = caption; Type = type; }

		/// <summary>
		/// ̎gp@̖O擾܂͐ݒ肵܂B
		/// ̒l̓j[ɕ\܂B
		/// </summary>
		/// <value>̎gp@̖O</value>
		public virtual string Caption{ get{ return caption; } set{ caption = value; } }
		private string caption;

		/// <summary>
		/// [U[j[NbNƂɃCX^X쐬^擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>[U[j[NbNƂɃCX^X쐬^</value>
		public Type Type{ get{ return type; } set{ type = value; } }
		private Type type;
	}


	/// <summary>
	/// vOCJX^ Evaluator ̎gݒ_CAOɊւ郍[JCYꂽJX^`܂B
	/// </summary>
	/// <remarks>
	/// <para>
	/// ̑w肷ƃvOCJX^ Evaluator Ɋւ\ׂ̃_CAO
	/// Greplace J悤ɂȂ܂B
	/// </para>
	/// </remarks>
	[AttributeUsage(AttributeTargets.Class|AttributeTargets.Assembly)]
	public class LocalizedOptionPageAttribute : OptionPageAttribute, ILocalizedAttribute
	{
		/// <summary>
		/// LocalizedOptionPageAttribute ̐VCX^X܂B
		/// ̑gp郊\[X̃x[X́AAZuɐݒ肳ꂽ <see>AssemblyLocalizedPluginInformationAttribute</see> 擾܂B
		/// </summary>
		/// <param name='resourceName'>̑gp郊\[X̃x[Xw肵܂B</param>
		/// <param name='caption'>̎gp@̐eLXgw肵܂B
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B
		/// </param>
		/// <param name='type'>[U[j[NbNƂɃCX^X쐬^w肵܂B</param>
		/// <seealso cref='GroupFinity.Greplace.AssemblyLocalizedPluginInformationAttribute'/>
		public LocalizedOptionPageAttribute( string caption, Type type ) : base( caption, type ){}

		/// <summary>
		/// LocalizedOptionPageAttribute ̐VCX^X܂B
		/// </summary>
		/// <param name='caption'>̎gp@̐eLXgw肵܂B
		/// ۂɂ͂̒l GetLocalizedString ɓnA
		/// [JCYꂽ擾̂Ɏgp܂B
		/// </param>
		/// <param name='type'>[U[j[NbNƂɃCX^X쐬^w肵܂B</param>
		public LocalizedOptionPageAttribute( string resourceName, string caption, Type type ) : base( caption, type ){ ResourceName = resourceName; }

		/// <summary>
		/// ̎gp@̖O擾܂͐ݒ肵܂B
		/// ̒l̓j[ɕ\܂B
		/// </summary>
		/// <value>̎gp@̖O</value>
		public override string Caption{ get{ return GetLocalizedString( base.Caption ); } set{ base.Caption = value; } }

		/// <summary>
		/// ̑gp郊\[X̃x[X擾܂͐ݒ肵܂B
		/// </summary>
		/// <value>̑gp郊\[X̃x[X</value>
		public string ResourceName{ get{ return resourceName; } set{ resourceName = value; } }
		private string resourceName;
		
		/// <summary>
		/// ̑\[X擾AZu擾܂͐ݒ肵܂B
		/// ̃vpeB Greplace ɂĎgp܂AvOCJ҂͎gpȂłB
		/// </summary>
		/// <value>̑\[X擾AZu</value>
		public Assembly Assembly{ get{ return assembly; } set{ assembly = value; } }
		private Assembly assembly;

		private string GetLocalizedString( string name )
		{
			try
			{
				if ( ResourceName==null )
				{
					AssemblyLocalizedPluginInformationAttribute attr =
						GetCustomAttribute( Assembly, typeof( AssemblyLocalizedPluginInformationAttribute ), true )
						as AssemblyLocalizedPluginInformationAttribute;
					if ( attr!=null ) ResourceName = attr.ResourceName;
				}

				return new ResourceManager( ResourceName, Assembly ).GetString( name );
			}
			catch{ return string.Empty; }
		}
	}
}
