using System;
using System.Text.RegularExpressions;

namespace GroupFinity.Greplace.StandardPlugin
{
	[LocalizedEvaluator("formatEvaluator","format")]
	[LocalizedEvaluatorUsage("omitDecimals", "${format:#: }" )]
	[LocalizedEvaluatorUsage("twoDecimalPlaces", "${format:#.##: }" )]
	[LocalizedEvaluatorUsage("alwaysTwoDecimalPlaces", "${format:#.00: }" )]
	[LocalizedEvaluatorUsage("threeDigitNumber", "${format:000: }" )]
	public class FormatEvaluator : IEvaluator
	{
		public string Evaluate( IGreppedText text, Match match, string input)
		{
			int next = input.LastIndexOf( ':' );
			if ( next<0 ) throw new Exception();
			string format = input.Substring( 0, next );
			string number = input.Substring( next+1 );
			return decimal.Parse( number, System.Globalization.NumberStyles.Any ).ToString( format );
		}
	}
}
